 
/** The data model represents a Farenheit temperature. */
public class TemperatureModel extends java.util.Observable
{
    /** The private data representing the current temperature */
    private double temperatureF = 32.0;

    /** Accessor to temperature */
    public double getF()
    {
        return temperatureF;
    }
    
    /** Set the temperature */
    public void setF(double tempF)
    {
        temperatureF = tempF;
        setChanged();
        notifyObservers();
    }
    /** Raise the temperature one degree */
    public void increment()
    {
        temperatureF = temperatureF + 1.0;
        setChanged();
        notifyObservers();
    }
    /** Lower the temperature one degree */
    public void decrement()
    {
        temperatureF = temperatureF - 1.0;
        setChanged();
        notifyObservers();
    }
       
}
